/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function ddg_oldSearch(){// For Mozilla 1.8.0
	this.RDFinit();
}

ddg_oldSearch.prototype={
	_RDFService: null,
	internetSearchDS: null,
	kNC_Root: null,
	kNC_child: null,
	kNC_Name: null,
	kNC_Icon: null,
	
	RDFinit : function(){
		this._RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
							.getService(nsCI.nsIRDFService);
		this.internetSearchDS = this._RDFService.GetDataSource("rdf:internetsearch");
		this.kNC_Root = this._RDFService.GetResource("NC:SearchEngineRoot");
		this.kNC_child = this._RDFService.GetResource("http://home.netscape.com/NC-rdf#child");
		this.kNC_Name = this._RDFService.GetResource("http://home.netscape.com/NC-rdf#Name");
		this.kNC_Icon = this._RDFService.GetResource("http://home.netscape.com/NC-rdf#Icon");
	},
 	_SS : null,
 	get SS(){
 		if(!this._SS){
 			this._SS = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch'].
								getService(nsCI.nsIInternetSearchService);
 		}
 		return this._SS;
 	},
 	
 	getSearchURL : function(engin, text){
 		var searchData = {url:null, postData:null};
 		engin = decodeURIComponent(engin);
 		engin = this.getRDFengine(engin);
 		var URL = this.SS.GetInternetSearchURL(engin, encodeURIComponent(text), 0, 0, {value: 0});
 		if(URL){
 			searchData.url = URL;
 			searchData.postData = null;
 		}
 		return searchData;
 	},
 	
 	getIconURL : function(engin){
 		var url = false;
 		engin = decodeURIComponent(engin);
		if(!this._RDFService) this.RDFinit();
		var engines = [];
		var plugins = this.internetSearchDS.GetTargets(this.kNC_Root, this.kNC_child, true);
		while (plugins.hasMoreElements()) {
			var plugin = plugins.getNext().QueryInterface(nsCI.nsIRDFResource);
			var name = this.readRDFString(this.internetSearchDS, plugin, this.kNC_Name);
			//ddgUtils.Log(plugin.Value);
			if(name == engin){
				url = this.readRDFString(this.internetSearchDS, plugin, this.kNC_Icon);
				break;
			}
		}
 		return url;
 	},
 	
 	getRDFengine : function(engin){
		if(!this._RDFService) this.RDFinit();
		var engines = [];
		var plugins = this.internetSearchDS.GetTargets(this.kNC_Root, this.kNC_child, true);
		while (plugins.hasMoreElements()) {
			var plugin = plugins.getNext().QueryInterface(nsCI.nsIRDFResource);
			var name = this.readRDFString(this.internetSearchDS, plugin, this.kNC_Name);
			//ddgUtils.Log(plugin.Value);
			if(name == engin)
				return plugin.Value;
		}
		return false;
 	},
 	
 	getEngines : function(){
 		var engines = [];
 		if(!this._RDFService) this.RDFinit();
 		var plugins = this.internetSearchDS.GetTargets(this.kNC_Root, this.kNC_child, true);
 		while (plugins.hasMoreElements()) {
			var plugin = plugins.getNext().QueryInterface(nsCI.nsIRDFResource);
			var name = this.readRDFString(this.internetSearchDS, plugin, this.kNC_Name);
			var id = plugin.Value;
			var icon = this.readRDFString(this.internetSearchDS, plugin, this.kNC_Icon);
			var newO=[];
			newO.id = id;
			newO.name = name;
			newO.iconpath = icon;
			engines.push(newO);
		}
		return engines;
 	},
	
	readRDFString : function(aDS, aRes, aProp){
		var n = aDS.GetTarget(aRes, aProp, true);
		return n ? n.QueryInterface(nsCI.nsIRDFLiteral).Value : null;
	},
	
	getCurSearchURL: function(searchStr){
 		var searchData = {url:null, postData:null};
		var searchEngine = ddg_ges.searchBox.ref.getAttribute('searchengine');
		if(searchEngine){
			searchData.url = this.SS.GetInternetSearchURL(searchEngine, encodeURIComponent(searchStr), 0, 0, {value: 0});
			return searchData;
		}
		var navigatorRegionBundle = document.getElementById("bundle_browser_region");
		var fallbackDefaultSearchURL = navigatorRegionBundle.getString("fallbackDefaultSearchURL");
		try {
			searchData.url = ddg_Preferences.pref.getComplexValue("browser.search.defaulturl",
				nsCI.nsIPrefLocalizedString).data;
		} catch (ex) {}
		if(!searchData.url)
			searchData.url = fallbackDefaultSearchURL;
		searchData.url += encodeURIComponent(searchStr);
		return searchData;
	}
}

function ddg_newSearch(){// For Mozilla 1.8.1 or later.
}

ddg_newSearch.prototype={
 	_SS : null,
 	get SS(){
 		if(!this._SS)
 			this._SS = Components.classes["@mozilla.org/browser/search-service;1"]
							.getService(nsCI.nsIBrowserSearchService);
 		return this._SS;
 	},
 	
 	getSearchURL : function(engin, text){
 		var searchData = {url:null, postData:null};
 		engin = decodeURIComponent(engin);
 		var submission = this.SS.getEngineByName(engin).getSubmission(text, null);
 		if (submission){
 			searchData.url = submission.uri.spec;
 			searchData.postData = submission.postData;
 		}
 		return searchData;
 	},
 	
 	getIconURL : function(engin){
 		var url = false;
 		engin = decodeURIComponent(engin);
 		engin = this.SS.getEngineByName(engin);
 		if(engin) url = engin.iconURI.spec;
 		return url;
 	},
 	
 	getEngines : function(){
		function _cloneEngine(aEngine) {
			var newO=[];
			newO.id = aEngine.name;
			newO.name = aEngine.name;
			newO.iconpath = aEngine.iconURI.spec;
			return newO;
		}
 		var engines = this.SS.getEngines({}).map(_cloneEngine);
		return engines;
 	},
	
	getCurSearchURL: function(searchStr){
 		var searchData = {url:null, postData:null};
		var engine = this.SS.currentEngine;
		if(engine){
			var submission = engine.getSubmission(searchStr, null);
			if (submission){
 				searchData.url = submission.uri.spec;
 				searchData.postData = submission.postData;
 				return searchData;
 			}
		}
		var navigatorRegionBundle = document.getElementById("bundle_browser_region");
		var fallbackDefaultSearchURL = navigatorRegionBundle.getString("fallbackDefaultSearchURL");
		try {
			searchData.url = ddg_Preferences.pref.getComplexValue("browser.search.defaulturl",
				nsCI.nsIPrefLocalizedString).data;
		} catch (ex) {}
		if(!searchData.url)
			searchData.url = fallbackDefaultSearchURL;
		searchData.url += encodeURIComponent(searchStr);
		return searchData;
	}
}
var ddg_Search = null;
if(/rv:1.8.0/.test(window.navigator.userAgent))
	ddg_Search = new ddg_oldSearch();
else
	ddg_Search = new ddg_newSearch();
